#!/bin/sh
# Ve2mrx + pcmike Mod cleanup + v24
# 2008-12-21c

#####check, if second instance is running#####
if [ -f ./data/backup.pid ]; then
  pid=$(cat ./data/backup.pid)
  rm ./data/backup.pid
fi
if [ "$pid" = "" ]; then
  pid="wrtbwlog_nopid"
fi
echo $$ > ./data/backup.pid

if [ "$(ps|grep $pid|grep backup.sh)" != "" ]; then
  kill $pid
fi

#####check, if ftpput is blocked by custom.sh#####
if [ -f ./data/custom.pid ]; then
  custpid=$(cat ./data/custom.pid)
fi
if [ "$custpid" = "" ]; then
  custpid="wrtbwlog_nopid"
fi
      
if [ "$(ps|grep $custpid|grep custom.sh)" = "" ]; then
  #####load config data#####
  if [ -f ./data/config ]; then
    destbc=$(cat "./data/config"|grep "wrt_destbc"|cut -d '=' -f2)
    pathbc=$(cat "./data/config"|grep "wrt_pathbc"|cut -d '=' -f2)
    ftpbac=$(cat "./data/config"|grep "wrt_ftpbac"|cut -d '=' -f2)
    usrbac=$(cat "./data/config"|grep "wrt_usrbac"|cut -d '=' -f2)
    pasbac=$(cat "./data/config"|grep "wrt_pasbac"|cut -d '=' -f2)
    rotbac=$(cat "./data/config"|grep "wrt_rotbac"|cut -d '=' -f2)
  fi

  #####if no config data, use default values#####
  if [ "$destbc" = "" ]; then
    destbc="FTP"
  fi

  if [ "$pathbc" = "" ]; then
    pathbc="/tmp/"
  fi
  
  if [ "$ftpbac" = "" ]; then
    ftpbac="192.168.1.100"
  fi
  
  if [ "$usrbac" = "" ]; then
    usrbac="wrt54g"
  fi
  
  if [ "$pasbac" = "" ]; then
    pasbac="wrt54g"
  fi
  
  if [ "$rotbac" = "" ]; then
    rotbac="/"
  fi

  #####backup#####
  if [ "$1" = "r" ]; then
    #####restore backup#####
    if [ -f ./bwdata.tgz ]; then
      rm bwdata.tgz
    fi
    if [ "$destbc" = "FLASH" ]; then
      #####restore from flash#####
      if [ -f ${pathbc}bwdata.tgz ]; then
        cp ${pathbc}bwdata.tgz ./bwdata.tgz
      fi
    else
      #####restore from ftp#####
      killall ftpget 2> /dev/null
      sleep 1
      ftpget -u "$usrbac" -p "$pasbac" "$ftpbac" bwdata.tgz "$rotbac"bwdata.tgz & 2> /dev/null
      sleep 5
      killall ftpget 2> /dev/null
    fi
    
    #####check default flash locations, if backup can't be found
    #####DD-WRT#####
    if [ ! -f ./bwdata.tgz ]; then    
      if [ -f /jffs/bwdata.tgz ]; then
        cp /jffs/bwdata.tgz ./bwdata.tgz
      fi
    fi
    #####Talisman#####
    if [ ! -f ./bwdata.tgz ]; then    
      if [ -f /usr/local/bwdata.tgz ]; then
        cp /usr/local/bwdata.tgz ./bwdata.tgz
      fi
    fi
    
    #####untar file#####
    if [ -f ./bwdata.tgz ]; then
      rm ./data/* 2> /dev/null
      tar -xzf bwdata.tgz
      rm bwdata.tgz
    fi
  else
    #####save backup#####
    # Ve2mrx+ pcmike mod for v.24 + cleanup
    #####tar file#####
    if [ -f ./bwdata.tgz ]; then
      rm bwdata.tgz
    fi
    if [ -f ./bwdata.tar ]; then
      rm bwdata.tar
    fi
    if [ -f ./bwdata.tar.gz ]; then
      rm bwdata.tar.gz
    fi
    tar -cf bwdata.tar ./data/
    gzip bwdata.tar
    if [ -f ./bwdata.tar ]; then
      rm bwdata.tar
    fi
    mv bwdata.tar.gz bwdata.tgz
    if [ "$destbc" = "FLASH" ]; then
      #####restore from FLASH#####
      if [ -f ${pathbc}bwdata.tgz ]; then
        rm ${pathbc}bwdata.tgz
      fi
      cp ./bwdata.tgz ${pathbc}bwdata.tgz
    else
      #####backup tp FTP#####
      killall ftpput 2> /dev/null
      sleep 1 
      ftpput -u "$usrbac" -p "$pasbac" "$ftpbac" "$rotbac"bwdata.tgz bwdata.tgz & 2> /dev/null
      sleep 5
    fi
    if [ -f ./bwdata.tgz ]; then
      rm bwdata.tgz
    fi
  fi
fi
