#!./haserl
Content-Type: text/html

<?
./header.sh

#####read configuration file#####
if [ -f "./data/config" ]; then
  debugm=$(cat "./data/config"|grep "wrt_debugm"|cut -d '=' -f2)
fi
  
#####if no data in config file, use default values#####
if [ "$debugm" = "" ]; then
  debugm="0"
fi
    
#####set taget of debugging output#####
if [ "$debugm" = "1" ]; then
  dbtarget="./data/errorlog"
else
  dbtarget="/dev/null"
fi

echo "<div class=\"floatbox\">"
echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME\" method=\"POST\" >"
echo "<input type=\"text\" class=\"TextBox\" style=\"width: 20em;\" name=\"command\"></br>"
echo "<input type=\"submit\" class=\"Button\" style=\"width: 100%;\" value=\"Run/Refresh\" >"
echo "</form>" 
echo "</div>"

echo "<br/><a href=\"#bottom\">To the end of the page.</a>"

echo "<table>"
echo "<tr><td><h3>Hostname</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/sys/kernel/hostname 2>> $dbtarget)</pre></td></tr>"
  
echo "<tr><td><h3>Linux version</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/version 2>> $dbtarget)</pre></td></tr>"
  
echo "<tr><td><h3>Uptime</h3></td></tr>"
echo "<tr><td><pre>$(uptime | sed -e "s/, load.*//" 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>CPU info</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/cpuinfo 2>> $dbtarget)</pre></td></tr>"
  
echo "<tr><td><h3>Load average</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/loadavg 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Memory</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/meminfo 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Running processes</h3></td></tr>"
echo "<tr><td><pre>$(ps -auwx 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Loaded modules</h3></td></tr>"
echo "<tr><td><pre>$(/sbin/lsmod 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Network interfaces</h3></td></tr>"
echo "<tr><td><pre>$(/sbin/ifconfig 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Routing table</h3></td></tr>"
echo "<tr><td><pre>$(/sbin/route -n 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Open sockets</h3></td></tr>"
echo "<tr><td><pre>$(netstat -tuan 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3># NAT entries</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/net/ip_conntrack | wc -l | sed -e "s/ *//" 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>ARP table</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/net/arp 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Dumpleases</h3></td></tr>"

firmware=$(/usr/sbin/nvram get firmware_version)
if [ "$(echo "$firmware"|grep "Talis")" != "" ] || [ "$(echo "$firmware"|grep "Free")" != "" ]; then
  killall -ALRM dnsmasq
  echo "<tr><td><pre>$(cat /tmp/udhcpd.leases 2>> $dbtarget)</pre></td></tr>"
else
  echo "<tr><td><pre>$(/usr/sbin/dumpleases 2>> $dbtarget)</pre></td></tr>"
fi

echo "<tr><td><h3>WLAN status</h3></td></tr>"
echo "<tr><td><pre>$(cat /proc/net/wl0 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN driver</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl ver 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN hardware</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl revinfo 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN capabilities</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl cap 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN tx power</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl txpwr1 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN transmission rate</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl rate 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN noise</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl noise 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN TX attenuation</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl atten 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN number of good/bad packets</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl pktcnt 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>WLAN associated clients</h3></td></tr>"
echo "<tr><td><pre>$(/usr/sbin/wl assoclist 2>> $dbtarget)</pre></td></tr>"

echo "<tr><td><h3>Command output ('$FORM_command')</h3></td></tr>"

if [ '$FORM_command' != "" ]; then
  echo "<tr><td>"
  echo "<pre>$($FORM_command)</pre>"
  echo "</td></tr>"
fi
?>

</table>
<a name="bottom"></a>

<?
./footer.sh
?>
