#!/bin/sh


if [ "$1" = "" ]; then
  stopmode="1lsh"
else
  stopmode="$1"
fi

if [ "$(echo "$stopmode" | grep "1")" != "" ]; then
  if [ "$(echo "$stopmode" | grep "l")" != "" ]; then
    #####kill wrtloop#####
    if [ "$(ps|grep wrtloop.sh|grep -v "grep wrtloop.sh")" != "" ]; then
      killall wrtloop.sh
    fi
  fi
  
  if [ "$(echo "$stopmode" | grep "s")" != "" ]; then
    #####kill other scripts#####
    echo "Please wait (~10s)..."
    sleep 5
    
    for script in $(find ./data/ -name "*.pid")
    do
      if [ "$script" != "./data/httpd.pid" ]; then
        pid=$(cat "$script")
        if [ "$pid" = "" ]; then
          pid="wrtbwlog_nopid"
        fi
        rm "$script"
        if [ "$(ps|grep "$pid"|grep "$(echo "$script"|cut -d '/' -f3|cut -d '.' -f1)")" != "" ]; then
          kill $pid
        fi
        pid=""
      fi
    done
  fi
  
  #####killl mini_httpd#####
  if [ "$(echo "$stopmode" | grep "h")" != "" ]; then
    #####get mini_httpd port#####
    if [ -f "./data/config" ]; then
      mhport=$(cat "./data/config"|grep "wrt_mhport"|cut -d '=' -f2)
    fi
    if [ "$mhport" = "" ]; then
      mhport="8000"
    fi
                
    #####kill old wrtbwlog mini_httpd instances#####
    if [ -f "./data/httpd.pid" ]; then
      pid="$(cat ./data/httpd.pid)"
      rm ./data/httpd.pid
    fi
    if [ "$pid" = "" ]; then
      pid="wrtbwlog_nopid"
    fi
    if [ "$(ps|grep mini_httpd|grep $pid)" != "" ]; then
      kill "$pid"
    fi
                                                        
    #####kill other httpd services on this port#####
    collpid="$(ps|grep httpd|grep $mhport|cut -d ' ' -f1)"
    if [ "$collpid" != "" ]; then
      kill $collpid
    fi
  fi
fi

if [ "$(echo "$stopmode" | grep "2")" != "" ]; then
  if [ "$(echo "$stopmode" | grep "s")" != "" ]; then
    #####kill all scripts in wrtbwlog folder#####
    scripts=`find ./ -name "*.sh"`
    for script in $scripts
    do
      script=`basename "$script"`
      if [ "$script" != "stop.sh" ]; then
        killall "$script" 2> /dev/null
      fi
    done
  fi
  
  if [ "$(echo "$stopmode" | grep "h")" != "" ]; then
    #####kill all mini_httpd instances#####        
    killall mini_httpd 2> /dev/null
  fi
fi
