#!/bin/sh

bwlogtrg="1"
billvoltrg="1"
assoctrg="1"
backuptrg="1"

while sleep 30; do

  #####get config data#####
  if [ -f "./data/config" ]; then
    intbac=$(cat "./data/config"|grep "wrt_intbac"|cut -d '=' -f2)
    trafac=$(cat "./data/config"|grep "wrt_trafac"|cut -d '=' -f2)
    limiac=$(cat "./data/config"|grep "wrt_limiac"|cut -d '=' -f2)
    backac=$(cat "./data/config"|grep "wrt_backac"|cut -d '=' -f2)
    acceac=$(cat "./data/config"|grep "wrt_acceac"|cut -d '=' -f2)
    debugm=$(cat "./data/config"|grep "wrt_debugm"|cut -d '=' -f2)
  fi
                  
  #####if no config data, use default value#####
  if [ "$intbac" = "" ]; then
    intbac="300"
  fi
  if [ "$trafac" = "" ]; then
    trafac="1"
  fi
  if [ "$limiac" = "" ]; then
    limiac="1"
  fi
  if [ "$backac" = "" ]; then
    backac="1"
  fi
  if [ "$acceac" = "" ]; then
    acceac="0"
  fi
  if [ "$debugm" = "" ]; then
    debugm="0"
  fi

  #####run trafic logging script#####
  if [ "$trafac" = "1" ]; then
    let "bwlogtrg+=30"
    if [ "$bwlogtrg" -gt "60" ]; then
      ./bwlog.sh &
      bwlogtrg="1"
    fi
  fi

  #####run traffic sentry script#####
  if [ "$limiac" = "1" ]; then
    let "billvoltrg+=30"
    if [ "$billvoltrg" -gt "300" ]; then
      ./billvol.sh &
      billvoltrg="1"
    fi
  fi

  ######run WLAN logging script#####
  if [ "$acceac" = "1" ]; then
    let "assoctrg+=30"
    if [ "$assoctrg" -gt "30" ]; then
      ./assoc.sh &
      assoctrg="1"
    fi
  fi

  #####backup the logs#####
  if [ "$backac" = "1" ]; then
    let "backuptrg+=30"
    if [ "$backuptrg" -gt "$intbac" ]; then
      ./backup.sh &
      backuptrg="1"
    fi
  fi
  
done
